@ECHO OFF
REM #############################################################
REM                CodeTyphon Studio 
REM      Copyright  PilotLogic Software House.
REM               All rights reserved.
REM #############################################################

title CodeTyphon Build Typhon BIG-IDE for Win64

SET path=C:\codetyphon\fpc\fpc64\bin\x86_64-win64;%path%

REM ----------- Check for Bitness------------------
Set _BITNESS=64
IF %PROCESSOR_ARCHITECTURE% == x86 (
  IF NOT DEFINED PROCESSOR_ARCHITEW6432 Set _BITNESS=32
  )  
REM -----------------------------------------------

if %_Bitness% == 32 (
ECHO.
ECHO [INFO]: Skip 64bit actions, this is 32 bits system... 
ECHO.
EXIT
)
REM -----------------------------------------------

if NOT EXIST ..\typhon\bin64\typhonbuild.exe (
 START /B /WAIT x_Typhon_Win64_Build_Small.bat
)

ECHO.
ECHO =====================================================================
ECHO             Build Typhon64 BIG-IDE for Win64
ECHO =====================================================================
ECHO.

if NOT EXIST ..\typhon\bin64\typhon.exe (
ECHO.
ECHO ??????????????????????????????????????????????????????
ECHO [ERROR]: Sorry, Typhon64 from Small-IDE NOT Build
ECHO          please remove and build Typhon again...
ECHO ??????????????????????????????????????????????????????
EXIT
)

if NOT EXIST ..\typhon\bin64\typhonbuild.exe (
ECHO.
ECHO ??????????????????????????????????????????????????????
ECHO [ERROR]: Sorry, typhonbuild64 from Small-IDE NOT Build
ECHO          please remove and build Typhon again...
ECHO ??????????????????????????????????????????????????????
EXIT
)

REM =================== Preparation =====================

if EXIST ..\typhon\bin64\CT_Is_BigIDE.ctsw (
 del /F /Q ..\typhon\bin64\CT_Is_BigIDE.ctsw
)

rename ..\typhon\bin64\typhon.exe styphon.exe

REM #############################################################
REM START /D ..\typhon\ /B /WAIT ..\fpc\fpc64\bin\x86_64-win64\make.exe bigide OPT="-g-" INSTALL_PREFIX=C:\codetyphon\typhon\

if EXIST ..\Settings\CT_Use_QT4.ctsw ( 
 START /D ..\typhon\ /B /WAIT ..\typhon\bin64\typhonbuild.exe -B --build-ide="-g- -dLCLqt" --ws=qt
 GOTO ENDBUILD
)

if EXIST ..\Settings\CT_Use_QT5.ctsw ( 
 START /D ..\typhon\ /B /WAIT ..\typhon\bin64\typhonbuild.exe -B --build-ide="-g- -dLCLqt5" --ws=qt5
 GOTO ENDBUILD
)

if EXIST ..\Settings\CT_Use_GTK2.ctsw ( 
 START /D ..\typhon\ /B /WAIT ..\typhon\bin64\typhonbuild.exe -B --build-ide="-g- -dLCLgtk2" --ws=gtk2
 GOTO ENDBUILD
)

if EXIST ..\Settings\CT_Use_GTK3.ctsw ( 
 START /D ..\typhon\ /B /WAIT ..\typhon\bin64\typhonbuild.exe -B --build-ide="-g- -dLCLgtk3" --ws=gtk3
 GOTO ENDBUILD
)

if EXIST ..\Settings\CT_Use_CustomDrawn.ctsw (
 START /D ..\typhon\ /B /WAIT ..\typhon\bin64\typhonbuild.exe -B --build-ide="-g- -dLCLcustomdrawn" --ws=customdrawn 
 GOTO ENDBUILD
)

if EXIST ..\Settings\CT_Use_fpGUI.ctsw (
 START /D ..\typhon\ /B /WAIT ..\typhon\bin64\typhonbuild.exe -B --build-ide="-g- -dLCLfpgui" --ws=fpgui
 GOTO ENDBUILD
)

START /D ..\typhon\ /B /WAIT ..\typhon\bin64\typhonbuild.exe -B --build-ide="-g- -dLCLwin32" --ws=win32

REM @@@@@@@@@@@@@@@@@@@@@@@@ ENDBUILD @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
:ENDBUILD

ECHO.

REM ================ if BIG-IDE Build OK ======================

IF EXIST ..\typhon\typhon.exe (

move /Y ..\typhon\*.exe ..\typhon\bin64\
del /F /Q ..\typhon\bin64\styphon.exe
copy /Y ..\binSettings\switcher\CT_Is_BigIDE.ctsw ..\typhon\bin64\

REM -------------- Build Tools ---------------

IF NOT EXIST ..\Settings\CT_NOT_Build_Tools.ctsw (
ECHO.
START /B /WAIT x_Typhon_Tools_Build.bat 64
)

REM -------------- Strip ----------------------------------

ECHO.
START /B /WAIT x_Typhon_Strip.bat 64

ECHO ------------------------------------------------------
ECHO.
ECHO [FINAL INFO]: Typhon64 BIG-IDE Build OK!!! Have fun.
ECHO.

) ELSE (

REM ================ if BIG-IDE NOT Build ======================

rename ..\typhon\bin64\styphon.exe typhon.exe
del /F /Q ..\typhon\*.exe

ECHO ------------------------------------------------------
ECHO.
ECHO ??????????????????????????????????????????????????????
ECHO [ERROR]: Typhon64 BIG-IDE IDE NOT Build
ECHO ??????????????????????????????????????????????????????
ECHO.
)

EXIT
